#include <config.h>

#include <sys/types.h>
#include <sys/time.h>

#include <stdio.h>
#include <stdlib.h>

#include <geta/dtypes.h>
#include <geta/dw.h>
#include <geta/dwut.h>
#include <geta/dxr.h>
#include <geta/dwam.h>

#define BLKSIZE 8192

int *
check_n_realloc_int_array(ptr, newsize, current, ival)
     int *ptr;
     size_t newsize;
     size_t *current;
     int ival;
{
  int *newptr;

  if (*current < newsize) {
    size_t i, old_current;
    old_current = *current;
    *current = NALIGN(newsize, BLKSIZE);
    if (!(newptr = realloc(ptr, ((*current)+1) * (sizeof *ptr)))) {
      perror("malloc");
      return NULL;
    }
    for (i = old_current+1; i <= *current; i++) newptr[i] = ival;
    return newptr;
  } else {
    return ptr;
  }
}

freq_t *
check_n_realloc_frq_array(ptr, newsize, current, ival)
     freq_t *ptr;
     size_t newsize;
     ssize_t *current;
     int ival;
{
  freq_t *newptr;

  if ((*current) < newsize) {
    size_t i;
	ssize_t old_current;
    old_current = *current;
    (*current) = NALIGN(newsize, BLKSIZE);
    if (!(newptr = realloc(ptr, (*current+1) * (sizeof *ptr)))) {
      perror("malloc");
      return NULL;
    }
    for (i = old_current+1; i <= *current; i++) newptr[i] = ival;
    return newptr;
  } else {
    return ptr;
  }
}
