/*
 *      Copyright (c) 2003 Shingo Nishioka.  All rights reserved.
 */

#if 0
static char rcsid[] = "$Id: butil.c,v 1.5 2007/03/24 02:52:58 nis Exp $";
#endif

#include <config.h>

#include <sys/param.h>
#include <sys/types.h>
#include <sys/time.h>

#include <assert.h>
#include <stdio.h>
#include <stdlib.h>

#include <geta/dtypes.h>
#include <geta/dw.h>
#include <geta/dwut.h>
#include <geta/dwerrno.h>
#include <geta/dcw.h>
#include <geta/dxr.h>
#include <geta/dwwt.h>
#include <geta/dwsh.h>

#include "bex.h"
#include "butil.h"

/*-----------------------------------------------------------------*/

/* q, qlen: wsh heno tuuzyou no hikisuu
   e, elen: bool expression. id==0 => attr=='(' | ')' | '&' | '|' | '!'
			     id!=0 => attr==0
*/

struct syminfo *
bex_conv(q, qlen, e, elen, olen)
struct syminfo const *q;
ssize_t qlen;
struct syminfo const *e;
ssize_t elen;
ssize_t *olen;
{
	struct syminfo *o, *op;
	struct syminfo const *qp;
	struct syminfo const *ep;
	ssize_t i, j;
	j = 0;

	if (!(o = calloc(qlen+1+elen+1, sizeof *o))) {
		return NULL;
	}

	for (i = 0; i<qlen; ) {
		qp = &q[i++];
		op = &o[j++];
		assert(qp->attr == 0);
		*op = *qp;
	}

	op = &o[j++];
	op->id = 0;
	op->attr = BEX_START;

	for (i = 0; i<elen; ) {
		ep = &e[i++];
		op = &o[j++];
		op->id = 0;
		if (ep->attr == '(') {
			op->attr = BEX_LPAR;
		}
		else if (ep->attr == ')') {
			op->attr = BEX_RPAR;
		}
		else if (ep->attr == '&') {
			op->attr = BEX_AND;
		}
		else if (ep->attr == '|') {
			op->attr = BEX_OR;
		}
		else if (ep->attr == '!') {
			op->attr = BEX_NOT;
		}
		else if (ep->attr == 'T') {
			op->attr = BEX_T;
		}
		else if (ep->attr == 'F') {
			op->attr = BEX_F;
		}
		else if (ep->attr == 0) {
			op->attr = BEX_ELEM;
			op->id = ep->id;
		}
		else {
			free(o);
			return NULL;
		}
	}

	op = &o[j++];
	op->id = 0;
	op->attr = BEX_END;

	assert(j==qlen+1+elen+1);
	*olen = j;
	return o;
}
