/*
 *	Copyright (C) 2001 Hitachi, Ltd.
 *	All rights reserved.
 *	Author: Shingo NISHIOKA
 *		nis@harl.hitachi.co.jp
 */

/* static char rcsid[] = "$Id: clist.c,v 1.3 2007/03/29 02:10:01 nis Exp $"; */

#include <config.h>

#include <sys/param.h>
#include <sys/time.h>

#include <assert.h>
#include <stdio.h>

#include <geta/dtypes.h>
#include <geta/dw.h>
#include <geta/dwut.h>

#include "tutil.h"

size_t
make_children_list(root, nnodes, c, all_descendants)
ssize_t root, *c;
size_t nnodes;
{
	ssize_t i, next;
	size_t j, k;

	if (root<-2) {
		return 0;
	}

	if (root==-2) {	/* ALL */
		for (j=0; j<nnodes; j++) {
			c[j] = j;
		}
		return j;
	}

#if 0
	/* tadasii? */
	if ((root+1)*2 >= nnodes) {
		return 0;
	}
#endif

	j=0;
	for (i=1; i<=root+1; i*=2) ;
	if ((next = root+i)<nnodes) {
		c[j] = next;
		for (j++; (next += i)<nnodes; j++) {
			c[j] = next;
			i*=2;
		}
	}

	if (all_descendants) {
		for (k=0; k<j; k++) {
			root = c[k];
			for (i=1; i<=root+1; i*=2) ;
			if ((next = root+i)<nnodes) {
				c[j] = next;
				for (j++; (next += i)<nnodes; j++) {
					c[j] = next;
					i*=2;
				}
			}
		}
	}

	return j;
}

#if defined SELF_TEST
main()
{
	ssize_t c[32];
	ssize_t root;
	size_t i, j;
	ssize_t nnodes = 14;
	int all;

	for (all=0; all<=1; all++) {
		for (root=-2; root<nnodes; root++) {
			j = make_children_list(root, nnodes, c, all);
			if (j) {
				printf("%d:", root);
				for (i=0; i<j; i++) {
					printf(" %d", c[i]);
				}
				printf("\n");
			}
		}
	}
}
#endif
