/*
 * Derived from wsh.c.in  by S.Nishioka
 * Sat Nov  8 15:20:13 JST 2003
 */

/* static char rcsid[] = "$Id: compar.c,v 1.2 2007/03/21 03:17:41 nis Exp $"; */

#include <config.h>

#include <sys/param.h>
#include <sys/types.h>
#include <sys/time.h>

#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <stdarg.h>
#include <math.h>
#include <assert.h>

#include <geta/dtypes.h>
#include <geta/dw.h>
#include <geta/dwut.h>
#include <geta/dwerrno.h>
#include <geta/nlog.h>
#include <geta/dcw.h>
#include <geta/dxr.h>
#include <geta/dwwt.h>
#include <geta/dwsh.h>

/*
 * この関数は dwam.c, tutil.c, cs.c で使われている.
 * なお, wsh.c にある dcompar とこの関数は同じでなければならない.
 */
int
sym_compar(va, vb)
void const *va, *vb;
{
	struct syminfo const *a, *b;
	a = va;
	b = vb;
	if (!fequal(a->weight, b->weight)) {
		/* descending order */
		if (a->weight < b->weight) {
			return 1;
		}
		else if (a->weight > b->weight) {
			return -1;
		}
	}
	else if (a->id < b->id) {
		return -1;
	}
	else if (a->id > b->id) {
		return 1;
	}
	return 0;
}

int
sym_icompar(va, vb)
void const *va, *vb;
{
	struct syminfo const *a, *b;
	a = va;
	b = vb;
	if (a->id < b->id) {
		return -1;
	}
	else if (a->id > b->id) {
		return 1;
	}
	return 0;
}
