/*
 *	Copyright (C) 2001 Hitachi, Ltd.
 *	All rights reserved.
 *	Author: Shingo NISHIOKA
 *		nis@harl.hitachi.co.jp
 */

/* static char rcsid[] = "$Id: defrq.c,v 1.1.1.1 2005/06/20 07:13:47 nis Exp $"; */

#include <config.h>

#if defined HAVE_LIBGEN_H
#include <libgen.h>
#endif
#include <limits.h>
#include <stdio.h>
#include <stdlib.h>

#include <geta/dtypes.h>
#include <geta/dw.h>
#include <geta/dwut.h>

static void usage(void);

char *progname = NULL;
static char buf[16384];

static void
usage()
{
	fprintf(stderr, "usage: %s #\n", progname);
	exit(1);
}

/* degrade frq file by selecting 1 out of # entries */
main(argc, argv)
char *argv[];
{
	size_t print;
	size_t de;
	char *end;

	progname = basename(argv[0]);

	if (argc!=2) {
		usage();
	}
	de = strtosize(argv[1], &end, 10);
	if (!(*argv[1] && !*end)) {
		usage();
	}
	if (de==0) {
		fprintf(stderr, "# must grater than 0\n");
		return 1;
	}

	for (print = de; fgets(buf, sizeof buf, stdin); ) {
		if (*buf=='@' || *buf=='#') {
			print++;
			if (print>=de) {
				print = 0;
			}
		}

		if (print==0) {
			fputs(buf, stdout);
		}
	}
	return 0;
}
