/*
 *	Copyright (C) 1994 Advanced Research laboratory, Hitachi, Ltd.
 *	Author: Shingo NISHIOKA
 *		nis@harl.hitachi.co.jp
 */

#include <config.h>

#include <sys/types.h>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "detache.h"
#include <geta/dtypes.h>
#include <geta/dw.h>
#include <geta/dwut.h>

#if ! HAVE_SETSID
#	if HAVE_SGTTY_H
#	include <sgtty.h>
#	endif
#	if HAVE_SYS_TERMIOS_H
#	include <sys/termios.h>
#	endif
#endif

int
detachetty()
{

	switch (fork()) {
#if HAVE_SETSID
		pid_t sid;
#elif HAVE_SYS_TERMIOS_H || HAVE_SGTTY_H
		int f;
#else
#	error
#endif
	case -1:
		return -1;
	case 0:
/* child */
#if HAVE_SETSID
		if ((sid = setsid()) == -1) {
			return -1;
		}
#elif HAVE_SYS_TERMIOS_H || HAVE_SGTTY_H
		if ((f = open("/dev/tty", 2)) != -1) {
			ioctl(f, TIOCNOTTY, 0);
			close(f);
		}
#else
#	error
#endif

		return 0;
		break;
	default:
		exit(0);
		/* NOTREACHED */
	}
}
