/*
 *	Copyright (c) 2004 Shingo Nishioka.  All rights reserved.
 */

#if 0
static char rcsid[] = "$Id: dtypes.h,v 1.18 2007/03/26 22:34:42 nis Exp $";
#endif

#include <arpa/inet.h>

/* 32bit id+freq (valid for ILP32, LP64) */
#define	IF32

/* 32bit id  64bit freq (valid for ILP32, LP64) */
/* #define	I32F64 */

/* 64bit id+freq (valid for LP64 only) */
/* WARNING: do not choose this configuration unless your architecutre is LP64 */
/* #define	IF64 */

/*
 * ILP32 : OK
 * LLP64 : NG -- pinter wo long ni kakunou dekiru to katei siteiru tame...
 * LP64 : OK
 * ILP64 : NG (not tested) --- see bitlist.h
 */

/* long long ha, dfs.c de 1 kasyo dake tukawarete iru */

/* Assertion:
 * sizeof(idx_t) <= sizeof(freq_t)
 * sizeof(idx_t) <= sizeof(size_t)
 * sizeof(df_t) == sizeof(idx_t)		singed v.s. unsigned
 * sizeof(freq_t) >< sizeof(size_t)
 * MAX(sizeof (freq_t), sizeof (idx_t)) <= sizeof (bitlist_reg_t)
 */

#if ENABLE_HETEROCLUSTER || defined IF64
typedef uint64_t pintcom_t;
#else
typedef size_t pintcom_t;
#endif
typedef uint32_t pintcom_s_t;
typedef uint32_t asig_t;

/*
 * 64bit env. de 32bit no df_t/idx_t wo sentaku suru, baai igai ha,
 * df_t ha, ssize_t no, idx_t ha size_t no betumei ni siteoita hou ga benri.
 * 32bit env. de 64bit no df_t/idx_t no sentaku ha dekinai.
 * freq_t ha ziyuu ni erabu kotoga dekiru.
 */

#define defbasictypes(IBITS, FBITS) \
typedef uint ## IBITS ## _t __idx_t; \
typedef int ## IBITS ## _t __df_t; \
typedef int ## FBITS ## _t __freq_t; \
typedef uint ## FBITS ## _t bitlist_reg_t; \

#if defined IF32
defbasictypes(32, 32)
#define IDX_T_MSB1      (0x1u << (sizeof (__idx_t) * 8 - 1))
#define	BITLIST_BPW 4
#endif

#if defined I32F64
defbasictypes(32, 64)
#define IDX_T_MSB1      (0x1u << (sizeof (__idx_t) * 8 - 1))
#define	BITLIST_BPW 8
#endif

#if defined IF64
defbasictypes(64, 64)
#define IDX_T_MSB1      (0x1ul << (sizeof (__idx_t) * 8 - 1))
#define	BITLIST_BPW 8
#endif

#undef defbasictypes

#define	dftostr(p)	(ltostr((p)))
#define	idxtostr(p)	(ultostr((p)))

#define	ssizetostr(p)	(ltostr((p)))
#define	sizetostr(p)	(ultostr((p)))
#define	sizetoxstr(p)	(ultoxstr((p)))
#define	ptrtoxstr(p)	(ultoxstr((unsigned long)(p)))
#define	strtosize(p, e, b) (strtoul((p), (e), (b)))

typedef __idx_t idx_t;
typedef __df_t df_t;
typedef __freq_t freq_t;
typedef size_t hash_t;

#define	ZEROVEC	{0, 0, {{0xdeadbeef, 0xdeadbeef}}}
