/*
 *	Copyright (C) 2000 Hitachi, Ltd.
 *	All rights reserved.
 *	Author: Shingo NISHIOKA
 *		nis@harl.hitachi.co.jp
 */

/* static char rcsid[] = "$Id: dwc.h,v 1.8 2007/03/24 02:52:58 nis Exp $"; */

struct syminfo;

#define	DWD_SERV	"dwd"
#define WVE_WRITE	(-1)

DWFILE *dwc_dxr_open(int, char const *, int, ssize_t, int);
DWFILE *dwc_dxr_create(int, char const *, size_t, int, int, ssize_t, size_t, int, int);

int dwc_flush(DWFILE *);
int dwc_flush_nowait(DWFILE *);
int dwc_flush_wait(DWFILE *);
int dwc_close(DWFILE *);
void dwc_disconnect(int);
int dwc_tcp_nodelay(DWFILE *);

ssize_t dwc_dxr_size(DWFILE *);
ssize_t dwc_dxr_get_vec(DWFILE *, idx_t, struct xr_vec const **);
int dwc_dxr_write_vec(DWFILE *, idx_t, struct xr_vec const *, ssize_t);
int dwc_add_trc_vec(DWFILE *, idx_t, struct xr_vec const *, int);

int dwc_dxr_set_mask(DWFILE *, idx_t *, size_t, idx_t *, size_t);

int dwc_dxr_seq_init(DWFILE *);
ssize_t dwc_dxr_seq_get_vec(DWFILE *, idx_t, struct xr_vec const **);
int dwc_dxr_seq_finish(DWFILE *);

DWFILE *dwc_file_open(int, char const *, int, ssize_t);
DWFILE *dwc_file_create(int, char const *, int, ssize_t);

int dwc_file_write_blk(DWFILE *, char const *, size_t);

int dwc_file_seq_init(DWFILE *);
int dwc_file_seq_recv_blk(DWFILE *, char const **, size_t *);
int dwc_file_seq_finish(DWFILE *);

int dwc_wshS(DWFILE *, struct syminfo const *, ssize_t, int, ssize_t, ssize_t, ssize_t, int);
ssize_t dwc_wshRs(DWFILE *, float **, ssize_t);
int dwc_wshRn(DWFILE *, ssize_t);
struct syminfo *dwc_wshR(DWFILE *, ssize_t *, ssize_t *, struct timeval *);

int dwc_wcmS(DWFILE *, struct syminfo const *, ssize_t, struct syminfo const *, ssize_t);
ssize_t **dwc_wcmR(DWFILE *);

ssize_t dwc_dxr_elem_num(DWFILE *, idx_t);
freq_t dwc_dxr_freq_sum(DWFILE *, idx_t);
ssize_t dwc_dxr_max_elem_num(DWFILE *);
freq_t dwc_dxr_max_freq_sum(DWFILE *);
freq_t dwc_dxr_total_elem_num(DWFILE *);
freq_t dwc_dxr_total_freq_sum(DWFILE *);

void dwd_serve(int, char const *);
