/*
 *	Copyright (C) 2000 Hitachi, Ltd.
 *	Author: Shingo NISHIOKA
 *		nis@harl.hitachi.co.jp
 */

/* static char rcsid[] = "$Id: dwsh.h,v 1.7 2007/03/24 04:57:22 nis Exp $"; */

#define	WSH_NONE	0
#define	WSH_OR		0
#define	WSH_AND		1
#define	WSH_NOT		2
#define	WSH_ORG		4

struct syminfo {
#define	SYMINFOPREFIX \
	idx_t id;	/* INPUT/OUTPUT */ \
	freq_t TF, TF_d;	/* INPUT/OUTPUT */ \
	freq_t DF, DF_d;	/* OUTPUT (INPUT) -- ssize_t */ \
	uint32_t attr;	/* INPUT */ \
	double weight;	/* OUTPUT (INPUT) */

	SYMINFOPREFIX

	int sel_score;

	union {		/* user data */
		struct {
			int i;
		} s;

		struct {
			int i;
			char const *pname;
			int sourcep;
			int x, y;
			union {
				double dfndf;
				char const *title;
			} t;
			char const *url;
			char const *property;
		} d;

		double idf;
	} u;
};

struct s_syminfo {
	SYMINFOPREFIX
};

struct oe_syminfo {
	SYMINFOPREFIX

	int64_t sel_score;

	union {		/* user data */
		struct {
			int64_t i;
			char const *pname;
			int64_t sourcep;
			int64_t x, y;
			union {
				double dfndf;
				char const *title;
			} t;
			char const *url;
			char const *property;
		} d;
	} u;

};

#undef SYMINFOPREFIX

int wsh_init(void);
struct syminfo *dw_wsh(struct syminfo const *, ssize_t, DWFILE *, DWFILE *, DWFILE *, int, ssize_t *, ssize_t *);
int sym_compar(void const *, void const *);
int sym_icompar(void const *, void const *);

/* hypGsum */
double hypGsum(int, int, int, int, int, int *);
void init_hypGsum(void);

/* psym */
struct s_syminfo;
size_t ssi_size(size_t);
void pack_ssi(struct s_syminfo *, struct syminfo const *, ssize_t);
void unpack_ssi(struct syminfo *, struct s_syminfo const *, ssize_t);

