/*
 *	Copyright (C) 2000 Central Research Laboratory, Hitachi, Ltd.
 *	Author: Shingo NISHIOKA
 *		nis@harl.hitachi.co.jp
 */

/* static char rcsid[] = "$Id: dxr.h,v 1.6 2007/03/24 02:52:58 nis Exp $"; */

struct xr_elem {
	idx_t id;
	freq_t freq;
};

struct xr_vec {
	df_t elem_num;
	freq_t freq_sum;
	struct xr_elem elems[1];
};

DWFILE *dxr_open(char const *, char const *);
int dxr_close(DWFILE *);
int dxr_mtime(DWFILE *);
ssize_t dxr_size(DWFILE *);

int dxr_need_dup_p(DWFILE *);
ssize_t dxr_get_vec(DWFILE *, idx_t, struct xr_vec const **);
ssize_t dxr_get_vec_dup(DWFILE *, idx_t, struct xr_vec const **);
ssize_t dxr_elem_num(DWFILE *, idx_t);
freq_t dxr_freq_sum(DWFILE *, idx_t);
ssize_t dxr_partition(DWFILE *, idx_t);
ssize_t dxr_max_elem_num(DWFILE *);
freq_t dxr_max_freq_sum(DWFILE *);
freq_t dxr_total_elem_num(DWFILE *);
freq_t dxr_total_freq_sum(DWFILE *);

struct xr_vec *dxr_dup(struct xr_vec const *);
int dxr_setf(DWFILE *, struct dfilt *, struct dfilt *);
char const *dxr_handle(DWFILE *);
char const *dxr_compress_type(DWFILE *);

int dxr_set_mask(DWFILE *, idx_t *, size_t, idx_t *, size_t);
