/*
 *	Copyright (C) 2000 Central Research Laboratory, Hitachi, Ltd.
 *	Author: Shingo NISHIOKA
 *		nis@harl.hitachi.co.jp
 */

/* static char rcsid[] = "$Id: dxrP.h,v 1.10 2007/03/24 05:17:50 nis Exp $"; */

#define	DXR_VERSION	0

#define DXR_MAGIC	354355

#define	RAWXR_TYPE_COUNT	'@'
#define	RAWXR_TYPE_RAW		'#'
#define	RAWXR_TYPE_ASCII	'%'
#define	RAWXR_TYPE_BINARY	'B'

struct dw_rfiles;
typedef struct dw_rfiles RFILES;

struct dxr_raw_elem {
	char const *name;
	freq_t tf; /* ftype == BINARY no toki niha, name no nagasa ga hairu koto ni tyuui. */
};

struct dxr_raw_vec {
	char const *key;
	char ftype;
	ssize_t elem_num;

	long pos;
	size_t key_len, elem_len;
	ssize_t frag;

	struct dxr_raw_elem elems[1];
};

struct dxr_hdr {
	u_char ident[16];
	int type;
	int version;
	int mtime;

	ssize_t fragment;
	size_t nentries;

	freq_t max_elem_num;
	freq_t max_freq_sum;
	freq_t total_elem_num;
	freq_t total_freq_sum;

	size_t entry_table_offset;
	size_t vector_table_offset;

	int compress_mode;	/* 0: none */

	int reserved[32-16];
};

struct dxr_entry {
	size_t addr;
	df_t elem_num;
	freq_t freq_sum;
};

struct dxr_zvec {	/* compressed vector */
	u_char zelems[1];
};

/* rawvec.c */
ssize_t read_raw_vec(RFILES *, struct dxr_raw_vec **);
RFILES *init_read_raw_vec(char **);
int finish_read_raw_vec(RFILES *);
int rewind_read_raw_vec(RFILES *);
void report_progress_raw_vec(RFILES *, FILE *, int);

#if defined X_READ_RAW_VEC
void rawvec_set_xread_param(RFILES *, int, double, int, double);
#endif

#define	sizeof_dxr_raw_vec(n)	(offsetof(struct dxr_raw_vec, elems[(n)]))
#define	sizeof_dxr_vec(n)	(offsetof(struct xr_vec, elems[(n)]))

struct com_dxr_hdr {
	uint32_t type;
	freq_t nentries, max_elem_num;	/* -- ssize_t */
	freq_t max_freq_sum, total_elem_num, total_freq_sum;
};
