/*
 *      Copyright (c) 2003 Shingo Nishioka.  All rights reserved.
 */

#if 0
static char rcsid[] = "$Id: gstat.c,v 1.3 2007/03/26 23:19:35 nis Exp $";
#endif

#include <config.h>

#include <sys/types.h>

#include <stdio.h>
#include <string.h>
#include <strings.h>

#include <geta/dtypes.h>
#include <geta/dw.h>
#include <geta/dwut.h>
#include "gstat.h"

struct gsb *gsb = NULL;

#define nelems(e)	(sizeof (e) / sizeof *(e))

void
gstat_init()
{
	static struct gsb gsb0;
	gsb = &gsb0;
	bzero(gsb, sizeof *gsb);
}

void
gstat_print(stream)
FILE *stream;
{
#ifdef GSTAT
	size_t i;
	int v, p = 1, a = 1;
	ssize_t min = -1, max;
	size_t hit = 0;
#endif

	if (!gsb) {
		return;
	}
#ifdef GSTAT
	for (i=0; i<nelems(gsb->xrpage); i++) {
		v = gsb->xrpage[i];
		if (min==-1 && v) {
			min = i;
		}
		if (v) {
			max = i;
			hit++;
		}
	}

	printf("gstat: %d min: %d max: %d hit: %d", nelems(gsb->xrpage), min, max, hit);

	for (i=0; i<nelems(gsb->xrpage); i++) {
		v = gsb->xrpage[i];
		if (p==0 && v==0) {
			if (a) {
				printf("*");
				a = 0;
			}
		}
		else {
			printf(" %d", v);
			a = 1;
		}
		p = v;
	}
	printf("\n");
#endif
}
