--
--	Copyright (C) 2002 Hitachi, Ltd.
--	All rights reserved.
--	Author: Shingo NISHIOKA
--		nis@harl.hitachi.co.jp
--

-- rcsid="$Id: XrElem.hs,v 1.1.1.1 2005/06/20 07:13:48 nis Exp $"

module XrElem(XrElem(XrElem, elemId, elemFreq)) where

import Ptr
import Storable

data XrElem = XrElem {elemId, elemFreq :: Int}

instance Show XrElem where
	showsPrec _ x = showsXrElem x

showsXrElem :: XrElem -> ShowS
showsXrElem e = ("[" ++) .
	shows (elemId e) . (", " ++) .
	shows (elemFreq e) . (']':)

xe0 = XrElem 0 0

iget :: Ptr a -> Int -> IO Int
iget a o = peek (castPtr (plusPtr a o))

iset :: Ptr a -> Int -> Int -> IO ()
iset a o v = poke (castPtr (plusPtr a o)) v

offsetofElemId = 0
offsetofElemFreq = offsetofElemId + sizeOf (elemId xe0)
sizeofXrElem = offsetofElemFreq + sizeOf (elemFreq xe0)

instance Storable XrElem where
	sizeOf a = sizeofXrElem
	alignment a = alignment (elemId a)

	peek a = do
		id <- iget a offsetofElemId
		freq <- iget a offsetofElemFreq
		return (XrElem id freq)
	poke a v = do
		iset a offsetofElemId (elemId v)
		iset a offsetofElemFreq (elemFreq v)
