#include <config.h>

#include <sys/types.h>

#include <errno.h>
#include <stdlib.h>

/*
 *	base[0..nmemb-1]	2*i+1 2*i+2 (nmemb+1)/2 .. nmemb-1
 */

struct hte { int v; };

void
heapsort(base, nmemb, compar)
struct hte *base;
size_t nmemb;
int (*compar)(const void *, const void *);
{
	struct hte x;
	size_t i, j;
	size_t l, r;

	if (nmemb == 0) {
		return;
	}

	l = (nmemb + 1)/2;
	r = nmemb - 1;

	while (0 < l) {
		l--;
		for (i = l, x = base[i]; (j = 2 * i + 1) <= r; i = j) {
			if (j + 1 <= r && (*compar)(&base[j], &base[j + 1]) < 0) {
				j++;
			}
			if ((*compar)(&base[j], &x) < 0) {
				break;
			}
			base[i] = base[j];
		}
		if (i != l) {
			base[i] = x;
		}
	}

	/* now, 0 .. r is heap. */

	while (0 < r) {
		x = base[r];
		base[r] = base[0];
		r--;

		for (i = 0; (j = 2 * i + 1) <= r; i = j) {
			if (j + 1 <= r && (*compar)(&base[j], &base[j + 1]) < 0) {
				j++;
			}
			if ((*compar)(&base[j], &x) < 0) {
				break;
			}
			base[i] = base[j];
		}
		base[i] = x;
	}
}
