/*
 *	Copyright (C) 2000 Hitachi, Ltd.
 *	All rights reserved.
 *	Author: Shingo NISHIOKA
 *		nis@harl.hitachi.co.jp
 */

/* static char rcsid[] = "$Id: iosched.h,v 1.5 2007/03/29 02:10:01 nis Exp $"; */

struct iosched;
struct sched_iocb;

typedef int mkrhost_t(struct iosched *, struct sched_iocb *, int, ssize_t);
typedef int custom_t(struct iosched *, char *);

struct sched_iocb {
	/* local */
	struct {
		char path[MAXPATHLEN];
		DWFILE *d;
		struct {
			struct dxr_hdr h;
		} dwc;
		struct {
			FILE *stream;
			size_t addr;
			struct dxr_entry *bindex;
			size_t n;
			int trc_vec;
		} remote;
	} L;

	/* net */
	struct {
		char const *host;
		char const *serv;
		DWFILE *f;
		DWFILE *g;
	} R;

	/* common */
	struct xr_vec *svec;
	ssize_t svec_elem_num;
	freq_t total_elem_num;
	ssize_t elem_num;
};

struct sched {
	size_t np;
	struct sched_iocb iocb0;
	struct sched_iocb *iocb;
	size_t n;		/* == nentries */
	size_t svec_size; /* == master size of iocb[*].svec in bytes. may be modified. */
	ssize_t max_elem_num, raw_max_elem_num;

	size_t onp;	/* == opposite_side_sched->np */

	ssize_t (*selpp)(struct sched *, idx_t);

	idx_t *pp;	/* used by selp_eqv_area */
};

struct iosched {
	char const *dirname, *handle;
	char path[MAXPATHLEN];
	char dcw_path[2][MAXPATHLEN];
	struct sched scc[2];
	struct {
		struct ht *h;
		size_t n;
	} tg[2];
	size_t v0size;	/* work area size of tracer */
/*
	struct {
		size_t ls, ss;
		int rehash;
	} h[2];
*/
	custom_t *custom;
	char *param;
	char const *type;
	mkrhost_t *mkrhost;
	int local;
	int compress;
};

struct hwfl {	/* hardwired functions list */
	char *name;
	void (*func)(void);
};

int print_sched(struct iosched *, FILE *);
int schedule_set_policy(struct iosched *, char *, char const *);
int schedule(struct iosched *, struct ht *, size_t, struct ht *, size_t, ssize_t);
