/*
 *	Copyright (C) 2003 Hitachi, Ltd.
 *	All rights reserved.
 *	Author: Shingo NISHIOKA
 *		nis@harl.hitachi.co.jp
 */

/* static char rcsid[] = "$Id: iov.c,v 1.2 2007/03/21 03:17:41 nis Exp $"; */

#include <config.h>

#include <sys/types.h>

#include <stdio.h>

#include <geta/dtypes.h>
#include <geta/dw.h>
#include <geta/dwut.h>

#include "iov.h"

#if ! defined(MIN)
#define MIN(a, b) ((a) < (b) ? (a) : (b))
#endif

ssize_t
safe_readv(d, iov, iovcnt)
const struct iovec *iov;
size_t iovcnt;
{
	size_t i, cnt;
	ssize_t e, ee, t;
	ssize_t y, z;
	struct iovec *iov0;

	for (i=0, t=0; i<iovcnt; t+=iov[i++].iov_len) ;

	iov0 = (struct iovec *)iov;
	cnt = iovcnt;
	y=iov0->iov_len, z=0;
	for (e=0; e<t; e+=ee) {
		ssize_t adj;
		struct iovec o;
		size_t c;

		for (; y<e; iov0++, y+=iov0->iov_len, cnt--) z=y;
		c = MIN(cnt, IOV_MAX);
		adj = e - z;
		o = *iov0;
		iov0->iov_base = (char *)iov0->iov_base+adj;
		iov0->iov_len -= adj;
		ee = readv(d, iov0, c);
		*iov0 = o;
		if (ee==-1) {
			return -1;
		}
		if (ee==0) {
			return e;
		}
	}
	return e;
}

ssize_t
safe_writev(d, iov, iovcnt)
const struct iovec *iov;
size_t iovcnt;
{
	size_t i, cnt;
	ssize_t e, ee, t;
	ssize_t y, z;
	struct iovec *iov0;

	for (i=0, t=0; i<iovcnt; t+=iov[i++].iov_len) ;

	iov0 = (struct iovec *)iov;
	cnt = iovcnt;
	y=iov0->iov_len, z=0;
	for (e=0; e<t; e+=ee) {
		ssize_t adj;
		struct iovec o;
		size_t c;

		for (; y<e; iov0++, y+=iov0->iov_len, cnt--) z=y;
		c = MIN(cnt, IOV_MAX);
		adj = e - z;
		o = *iov0;
		iov0->iov_base = (char *)iov0->iov_base+adj;
		iov0->iov_len -= adj;
		ee = writev(d, iov0, c);
		*iov0 = o;
		if (ee==-1) {
			return -1;
		}
		if (ee==0) {
			return e;
		}
	}
	return e;
}
