/*
 *	Copyright (c) 2004 Shingo Nishioka.  All rights reserved.
 */

#if 0
static char rcsid[] = "$Id: mmalloc.h,v 1.5 2007/03/21 23:55:14 nis Exp $";
#endif

/*
 * libdw:
 *
 * cw (row) 		mmap(CWR_BASE)
 *	0x0100 00000000
 *
 * cw (col) 		mmap(CWC_BASE)
 *	0x0180 00000000
 *
 * xr (row)		mmap(XRR_BASE)
 *	0x0200 00000000
 *
 * xr (col)		mmap(XRC_BASE)
 *	0x0280 00000000
 */

/*
 * dwdserv:
 *
 * r->bindex 		mmalc(BI_BASE)
 *	0x0001 00000000
 */

/*
 * mkdw:
 *
 * text/bss/heap
 *	0x0000 00400000
 * 
 * mmap
 *	0x0000 40000000
 * 
 * fullwd (row)		sdup_init(RS_BASE)
 *	0x0001 00000000	(28G)
 * 
 * fullwd (col)		sdup_init(CS_BASE)
 *	0x0008 00000000	(32G)
 * 
 * r-index (row)	make_{bin,hash}_index(RI_BASE)
 *	0x0010 00000000	(32G)
 * 
 * r-index (col)	make_{bin,hash}_index(CI_BASE)
 *	0x0018 00000000	(32G)
 * 
 * row hash table	nht_init(RH_BASE)
 *	0x0020 00000000	(64G)
 *
 * col hash table	nht_init(CH_BASE)
 *	0x0030 00000000	(64G)
 * 
 * v0			xmmalc(V0_BASE)
 *	0x0040 00000000
 * 
 * stack
 *	0x8000 00000000
 */

/* valid only for LP64 */
/* #define	FIXED_MEM */

/* ***: if FIXED_MEM is defined, 
        malloc should return conjective memory block for this segment */

#if defined FIXED_MEM
#define	BI_BASE 0x000100000000ul
#define RS_BASE 0x000100000000ul	/* *** */
#define CS_BASE 0x000800000000ul	/* *** */
#define RI_BASE 0x001000000000ul
#define CI_BASE 0x001800000000ul
#define RH_BASE 0x002000000000ul	/* *** */
#define CH_BASE 0x003000000000ul	/* *** */
#define V0_BASE 0x004000000000ul
#define	AMEM	0x000140000000ul	/* 5G */
#else
#define	BI_BASE 0x0
#define RS_BASE 0x0
#define CS_BASE 0x0
#define RI_BASE 0x0
#define CI_BASE 0x0
#define RH_BASE 0x0
#define CH_BASE 0x0
#define V0_BASE 0x0
#define	AMEM	0x0			/* not used */
#endif

void *mmalc(void *, size_t);
void *xmmalc(void *, size_t);
void *mmalloc(size_t);
void mmfree(void *, size_t);
size_t mmtotal(void);
