/*
 *	Copyright (c) 2005 Shingo Nishioka.  All rights reserved.
 */

#if 0
static char rcsid[] = "$Id: mymem.c,v 1.1.1.1 2005/06/20 07:13:48 nis Exp $";
#endif

#define MYMEM_C

#include <sys/param.h>
#include <sys/mman.h>
#include <sys/resource.h>

#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>

#include <config.h>
#include <geta/dtypes.h>
#include <geta/dw.h>
#include <geta/dwut.h>

#if defined MYMEM

void *
xmalloc(size)
size_t size;
{
	void *e = malloc(size);
	fprintf(stderr, "malloc[%d]: %08x %d => %p\n", getpid(), *((int *)&size - 1), size, e);
	return e;
}

void *
xcalloc(number, size)
size_t number, size;
{
	void *e = calloc(number, size);
	fprintf(stderr, "calloc[%d]: %08x %d %d => %p\n", getpid(), *((int *)&number - 1), number, size, e);
	return e;
}

void *
xrealloc(ptr, size)
void *ptr;
size_t size;
{
	void *e = realloc(ptr, size);
	fprintf(stderr, "realloc[%d]: %08x %p %d => %p\n", getpid(), *((int *)&ptr - 1), ptr, size, e);
	return e;
}

void
xfree(ptr)
void *ptr;
{
	fprintf(stderr, "free[%d]: %08x %p => void\n", getpid(), *((int *)&ptr - 1), ptr);
	return free(ptr);
}

void *
xmmap(addr, len, prot, flags, fd, offset)
void *addr;
size_t len;
off_t offset;
{
	void *e = mmap(addr, len, prot, flags, fd, offset);
	fprintf(stderr, "mmap[%d]: %08x %d - %d => %p\n", getpid(), *((int *)&addr - 1), len, (int)offset, e);
	return e;
}

int
xmunmap(addr, len)
void *addr;
size_t len;
{
	int e = munmap(addr, len);
	fprintf(stderr, "mummap[%d]: %08x %p - %d => %d\n", getpid(), *((int *)&addr - 1), addr, len, e);
	return e;
}

void
report_res(name)
char const *name;
{
#define REPRLIM(resource) do { \
		struct rlimit rl; \
		if (getrlimit(resource, &rl) == 0) { \
			fprintf(stderr, "%s: "#resource ": %d %d\n", name, rl.rlim_cur, rl.rlim_max); \
		} \
	} while (0)
	REPRLIM(RLIMIT_DATA);
}

#endif
