/*
 *	Copyright (c) 2004 Shingo Nishioka.  All rights reserved.
 */

#if 0
static char rcsid[] = "$Id: nht.h,v 1.4 2007/03/24 00:32:56 nis Exp $";
#endif

/* #define	THRESHOLD(t)	((t) / 4 * 3) */
#define	THRESHOLD(t)	((t) / 7 * 6)

/* #define	THRESHOLD_1(t)	((t) / 3 * 4) */
#define	THRESHOLD_1(t)	((t) / 6 * 7)

struct ht;

struct hte {
	union {
		char *p;
		size_t u;	/* mkmonolithic で使用 */
	} name;
	struct {
		freq_t tf;
		df_t df;
		idx_t id;
	} i;
};

struct ht {
	size_t size;
	size_t nentries;
	size_t threshold;
	struct hte *base, *pend;
	size_t nbases, bases_size;
	struct hte **bases;
	int monolithic;
	size_t fragsz;
	struct {
		size_t max, total;
		size_t dist[9];
	} stat;
};

#define	NHT_RDWR	0
#define	NHT_RDONLY	1

#define	hta(h, i)	((h)->monolithic == 0 ? _hta((h), (i)) : &(h)->base[(i)])

struct ht *nht_init(void *);
void nht_free(struct ht *);
size_t nht_nent(struct ht *);
struct hte *nht_enter(struct ht *, char const *, struct sdup *);
struct hte *nlt_append(struct ht *, char const *, struct sdup *);
void nht_compact(struct ht *, size_t *, int);
struct hte *_hta(struct ht *, size_t);
int nht_sort(struct ht *, size_t, int (*)(const void *, const void *));
void nht_refresh(struct ht *);
