/*
 *	Copyright (C) 2001 Hitachi, Ltd.
 *	All rights reserved.
 *	Author: Shingo NISHIOKA
 *		nis@harl.hitachi.co.jp
 */

/* static char rcsid[] = "$Id: psym.c,v 1.6 2007/03/24 02:52:58 nis Exp $"; */

#include <config.h>

#include <sys/types.h>
#include <sys/time.h>

#include <stdio.h>
#include <stdarg.h>
#include <stddef.h>
#include <string.h>
#include <strings.h>

#include <geta/dtypes.h>
#include <geta/dw.h>
#include <geta/dwut.h>
#include <geta/dwerrno.h>
#include <geta/dcw.h>
#include <geta/dxr.h>
#include <geta/dwwt.h>
#include <geta/dwsh.h>

void
pack_ssi(r, q, n)
struct s_syminfo *r;
struct syminfo const *q;
ssize_t n;
{
	size_t i;
#if 0
fprintf(stderr, "pack_ssi<: ");
for (i = 0; i < n; i++) {
	fprintf(stderr, "{%s}, ", idxtostr(q[i].id));
}
fprintf(stderr, "\n");
#endif
	for (i=0; i<n; i++) {
		bcopy(&q[i], &r[i], sizeof r[i]);
	}
#if 0
fprintf(stderr, "pack_ssi>: ");
for (i = 0; i < n; i++) {
	fprintf(stderr, "{%s}, ", idxtostr(r[i].id));
}
fprintf(stderr, "\n");
#endif
}

void
unpack_ssi(q, r, n)
struct syminfo *q;
struct s_syminfo const *r;
ssize_t n;
{
	size_t i;
	if (n == 0) {
		return;
	}
#if 0
fprintf(stderr, "unpack_ssi<: ");
for (i = 0; i < n; i++) {
	fprintf(stderr, "{%s}, ", idxtostr(r[i].id));
}
fprintf(stderr, "\n");
#endif
	i = n - 1;
	do {
		bcopy(&r[i], &q[i], sizeof r[i]);
	} while (i-- != 0);
#if 0
fprintf(stderr, "unpack_ssi>: ");
for (i = 0; i < n; i++) {
	fprintf(stderr, "{%s}, ", idxtostr(q[i].id));
}
fprintf(stderr, "\n");
#endif
}
