/*
 *	Copyright (C) 2001 Hitachi, Ltd.
 *	All rights reserved.
 *	Author: Shingo NISHIOKA
 *		nis@harl.hitachi.co.jp
 */

/* static char rcsid[] = "$Id: random.c,v 1.2 2007/03/29 07:37:38 nis Exp $"; */

#include <config.h>

#include <stdio.h>
#include <stdlib.h>

#include <geta/dtypes.h>

#define	L	"(define *random-ints* '("
#define	P	"@my_random_list = ("

#define	SCHEME	0
#define	PERL	1

char *progname = NULL;

static void
usage()
{
	fprintf(stderr, "usage: %s # [scheme|perl]\n", progname);
	exit(1);
}

main(argc, argv)
char *argv[];
{
	size_t i, c;
	size_t lim;
	char *l;
	int type;
	char *e;

	progname = argv[0];
	if (argc!=3) {
		usage();
	}
	lim = strtosize(argv[1], &e, 10);
	if (*e) {
		usage();
	}

	if (!strcmp(argv[2], "scheme")) {
		type = SCHEME;
	}
	else if (!strcmp(argv[2], "perl")) {
		type = PERL;
	}
	else {
		usage();
	}

	l = type==SCHEME?L:P;
	printf("%s", l);
	c = strlen(L);
	srandom(1);
	for (i=0; i<lim; i++) {
		int r;
		char s[32];
		r = random();
		sprintf(s, "%d%s", r, type==SCHEME||i==lim-1?"":",");
		printf("%s", s);
		if ((c+=strlen(s)+1)>=70) {
			printf("\n");
			c = 0;
		}
		else if (i==lim-1) {
			/* nothing to do */
		}
		else {
			printf(" ");
		}
	}
	l = type==SCHEME?"))":")";
	printf("%s\n", l);
	return 0;
}
