/*
 *	Copyright (C) 2000 Hitachi, Ltd.
 *	All rights reserved.
 *	Author: Shingo NISHIOKA
 *		nis@harl.hitachi.co.jp
 */

/* static char rcsid[] = "$Id: ssum.c,v 1.8 2007/03/29 02:10:01 nis Exp $"; */

#include <config.h>

#include <sys/param.h>
#include <sys/socket.h>
#include <sys/time.h>

#include <assert.h>
#include <netdb.h>
#include <stdarg.h>
#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>

#include <geta/dtypes.h>
#include <geta/dw.h>
#include <geta/dwut.h>
#include <geta/nlog.h>
#include <geta/dcw.h>
#include <geta/dxr.h>
#include <geta/dwwt.h>
#include <geta/dwsh.h>
#include <geta/dwc.h>
#include <geta/dwsched.h>

#include "tutil.h"
#include "nnet.h"

/* dir, handle wo atae rarete,
   sono WAM tyuu no DF ga 0 no vector no kazu wo kazoeru.
   TCP/IP ban nomi. */

static int zzz(struct rcxs *);
static int yyy(ssize_t, DWFILE *);

int
main(argc, argv)
char *argv[];
{
	char *dirname, *handle;
	struct dwsched ds;

	if (argc != 3) {
		fprintf(stderr, "usage: %s dir handle\n", argv[0]);
		return 1;
	}

	dirname = argv[1];
	handle = argv[2];

	if (read_dwsched(&ds, dirname, handle)) {
		fprintf(stderr, "read_dwsched failed: %s, %s\n", dirname, handle);
		return 1;
	}

	zzz(&ds.rcx[0]);

	return 0;
}

static int
zzz(df)
struct rcxs *df;
{
	ssize_t p;

	for (p=0; p<df->np; p++) {
		struct rcxsp *rp = &df->rems[0][p]; /* use non-cascade rems */
		int s;
		if ((s = nnet_cli(rp->host, rp->serv))==-1) {
			nperror(rp->host);
			nperror("nnet_cli");
			return -1;
		}
		rp->s = s;	/* for random-order-wsh */
		assert(p==rp->i.fragment);
		if (!(rp->f = dwc_dxr_open(s, rp->i.handle, rp->i.type, p, -1))) {
			nperror(rp->host);
			nperror("dwc_dxr_open");
			return -1;
		}
		yyy(p, rp->f);
		dwc_close(rp->f);
		rp->f = NULL;
		rp->s = -1;
	}

	return 0;
}

static int
yyy(p, f)
ssize_t p;
DWFILE *f;
{
	ssize_t size;
	size_t zerocnt, nzcnt;
	idx_t i;
	ssize_t e;

	size = dwc_dxr_size(f);
	zerocnt = nzcnt = 0;

	for (i = 1; i<=size; i++) {
		struct xr_vec const *v;
		e = dwc_dxr_get_vec(f, i, &v);
		if (e==0) {
			zerocnt++;
		}
		else {
			nzcnt++;
		}
	}

	printf("%s: %s %s/%s\n", sizetostr(p), ssizetostr(size), sizetostr(zerocnt), sizetostr(nzcnt));

	return 0;
}
