/*
 *	Copyright (C) 2001 Hitachi, Ltd.
 *	All rights reserved.
 *	Author: Shingo NISHIOKA
 *		nis@harl.hitachi.co.jp
 */

/* static char rcsid[] = "$Id: strlcpy.c,v 1.1.1.1 2005/06/20 07:13:48 nis Exp $"; */

#include <sys/types.h>

#include <config.h>

#include <string.h>
#include <strings.h>

#include <geta/dtypes.h>
#include <geta/dw.h>
#include <geta/dwut.h>

#if ! HAVE_STRLCPY
size_t
strlcpy(dst, src, size)
char *dst;
const char *src;
size_t size;
{
	size_t l, c;
	c = l = strlen(src);
	if (size==0) {
		return l;
	}
	if (c > size-1) {
		c = size-1;
	}
	memmove(dst, src, c);
	dst[c] = '\0';
	return l;
}
#endif

#if ! HAVE_STRLCAT
size_t
strlcat(dst, src, size)
char *dst;
const char *src;
size_t size;
{
	size_t l, k, c;
	c = l = strlen(src);
	k = strlen(dst);
	if (size==0) {
		return k+l;
	}
	if (k >= size-1) {
		dst[size-1] = '\0';
	}
	if (c > size-k-1) {
		c = size-k-1;
	}

	memmove(dst+k, src, c);
	dst[k+c] = '\0';
	return k+l;
}
#endif
