;;;
;;;	Copyright (C) 2001 Hitachi, Ltd.
;;;	All rights reserved.
;;;	Author: Shingo NISHIOKA
;;;		nis@harl.hitachi.co.jp
;;;

;;; rcsid="$Id: dwi.scm,v 1.2 2007/03/29 03:21:19 nis Exp $"

(define wam:port 0)

(define (wam:init projectroot)
  (set! wam:port (wam:open-swam-port))
  (wam:client wam:port 'wam_init projectroot))

(define (wam:finish)
  (wam:close-swam-port wam:port)
  (set! wam:port 0))

(define (wam:open handle)
  (wam:client wam:port 'wam_open handle))

(define (wam:size wam dir)
  (wam:client wam:port 'wam_size wam dir))

(define (wam:elem_num wam dir id)
  (wam:client wam:port 'wam_elem_num wam dir id))

(define (wam:freq_sum wam dir id)
  (wam:client wam:port 'wam_freq_sum wam dir id))

(define (wam:max_elem_num wam dir)
  (wam:client wam:port 'wam_max_elem_num wam dir))

(define (wam:max_freq_sum wam dir)
  (wam:client wam:port 'wam_max_freq_sum wam dir))

(define (wam:total_elem_num wam dir)
  (wam:client wam:port 'wam_total_elem_num wam dir))

(define (wam:total_freq_sum wam dir)
  (wam:client wam:port 'wam_total_freq_sum wam dir))

(define (wam:id2name wam dir id)
  (wam:client wam:port 'wam_id2name wam dir id))

(define (wam:name2id wam dir id)
  (wam:client wam:port 'wam_name2id wam dir id))

(define (wam:get_vec wam dir id)
  (wam:client wam:port 'wam_get_vec wam dir id))

(define (wam:make-sym-elem id name TF TF_d DF DF_d weight attr)
  (list->vector (list id name TF TF_d DF DF_d weight attr)))

(define (wam:wsh q wam dir weight_type maxnd takano_iw_limit target_wam)
  (let ((maxprec (lambda (q)
		   (map (lambda (e)
			  (vector-set! e 6
				       (number->string (vector-ref e 6)))
			  e)
			q))))
    (wam:client wam:port 'wam_wsh (maxprec q) wam dir weight_type maxnd takano_iw_limit target_wam)))

(define (wam:getprop handle dir path id)
  (wam:client wam:port 'wam_getprop handle dir path id))

(define (wam:wstem string wam dir jma_path)
  (wam:client wam:port 'wam_wstem string wam dir jma_path))

(define (wam:get_weight_types)
  (wam:client wam:port 'wam_get_weight_types))

;(define (wam:ci_value handle name)
;  (wam:client wam:port 'wam_ci_value handle name))

(define (wam:idl2namel wam dir l)
  (wam:client wam:port 'wam_idl2namel wam dir l))

(define (wam:namel2idl wam dir l)
  (wam:client wam:port 'wam_namel2idl wam dir l))

(define (wam:close wam)
  (wam:client wam:port 'wam_close wam))
