/*
 *	Copyright (C) 2001 Hitachi, Ltd.
 *	All rights reserved.
 *	Author: Shingo NISHIOKA
 *		nis@harl.hitachi.co.jp
 */

/* static char rcsid[] = "$Id: eval.c,v 1.4 2007/03/29 03:21:19 nis Exp $"; */

#include <config.h>

#include <sys/param.h>
#include <sys/time.h>

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include <geta/dtypes.h>
#include <geta/dwut.h>
#include <geta/dw.h>
#include <geta/dcw.h>
#include <geta/dxr.h>
#include <geta/daui.h>
#include <geta/dwwt.h>
#include <geta/dwsh.h>
#include <geta/dwc.h>
#include <geta/dwsched.h>
#include <geta/dci.h>
#include <geta/dwam.h>

#include "sexp.h"
#include "swam.h"

static struct {
	char *name;
	void (*func)(int, sexp, FILE *);
} ftbl[] = {
#define	F(n)	{#n, s##n}
	F(wam_init),
	F(wam_open),
	F(wam_close),
	F(wam_size),
	F(wam_elem_num),
	F(wam_freq_sum),
	F(wam_max_elem_num),
	F(wam_max_freq_sum),
	F(wam_total_elem_num),
	F(wam_total_freq_sum),
	F(wam_name2id),
	F(wam_id2name),
	F(wam_get_vec),
	F(wam_wsh),
	F(wam_getprop),
	F(wam_wstem),
	F(wam_wstemv),
	F(wam_get_weight_types),
#if USE_CICONF
	F(wam_ci_value),
#endif
	F(wam_namel2idl),
	F(wam_idl2namel),
	};
#undef F

int
docmd(r, stream)
sexp r;
FILE *stream;
{
	sexp func = car(r);
	sexp argv = cdr(r);
	int argc = length(argv);
	char const *fname;
	size_t i;

	if (!(fname = symbol_name(func))) {
fprintf(stderr, "fname==NULL\n");
		fprintf(stream, "()");
		return -1;
	}
	for (i=0; i<nelems(ftbl); i++) {
		if (!strcmp(fname, ftbl[i].name)) {
			(*ftbl[i].func)(argc, argv, stream);
			return 0;
		}
	}
	if (i==nelems(ftbl)) {
fprintf(stderr, "unknown fname: [%s]\n", fname);
		fprintf(stream, "()");
	}
	return -1;
}
