/*
 *	Copyright (C) 2000 Hitachi, Ltd.
 *	All rights reserved.
 *	Author: Shingo NISHIOKA
 *		nis@harl.hitachi.co.jp
 */

/* static char rcsid[] = "$Id: timer.c,v 1.3 2007/03/21 03:17:41 nis Exp $"; */

#include <config.h>

#include <sys/param.h>
#include <sys/time.h>

#include <stdio.h>

#include <geta/dtypes.h>
#include <geta/dw.h>
#include <geta/dwut.h>
#include <geta/timer.h>

void
timeridiv(p, n, r)
struct timeval *p, *r;
{
	r->tv_usec = (p->tv_sec % n)/(double)n * 1000000 + p->tv_usec/n;
	r->tv_sec = p->tv_sec / n;
	if (r->tv_usec >= 1000000) {
		r->tv_usec -= 1000000;
		r->tv_sec++;
	}
}

void
timerprint(stream, t)
FILE *stream;
struct timeval *t;
{
/*
	fprintf(stream, "%ld.%03ld", t->tv_sec, t->tv_usec / 1000);
*/
	fprintf(stream, TIMERFMT, TIMERSCL(t));
}
