/*
 *	Copyright (C) 2000 Hitachi, Ltd.
 *	All rights reserved.
 *	Author: Shingo NISHIOKA
 *		nis@harl.hitachi.co.jp
 */

/* static char rcsid[] = "$Id: tutil.h,v 1.7 2007/03/29 07:37:38 nis Exp $"; */

struct syminfo;

struct qqs {
	DWFILE *xr, *qs, *ds;
};

struct sym_vec {
	int active;

	ssize_t nodeid;
	struct rcxsp *rem;
	struct qqs *q;

	ssize_t n;
	struct syminfo *s;
	struct timeval elapsed;

	ssize_t nsum;
	float *sum;

	/* for prob_mode */
	double p;
	ssize_t srn;

#if defined RORDER_WSH
	/* for random-order-wsh */
	int received;
#endif

	/* for cm */
	ssize_t **c;
};

int rcxsp_connect_n_open(struct rcxsp *, int);

ssize_t mksum(struct syminfo *, ssize_t, float **, ssize_t);
ssize_t makesv(ssize_t, size_t, struct rcxsp **, struct sym_vec **, struct qqs *, int);
struct syminfo *rdwsh(struct syminfo const *, ssize_t, struct sym_vec *, ssize_t, int, ssize_t *, ssize_t, ssize_t *, ssize_t, int, int);

size_t make_children_list(ssize_t, size_t, ssize_t *, int);

ssize_t **rdwcm(struct syminfo const *, ssize_t, struct syminfo const *, ssize_t, struct sym_vec *, ssize_t, int);

void clear_timers(void);
void print_timers(FILE *, struct timeval *);

struct gtim;
struct gtim *get_gtim(void);
void merge_gtim(struct gtim const *, struct gtim const *, struct gtim *);
void print_gtim(FILE *, struct timeval *, struct gtim *);

int dlm_match(char const *, char const *);
int dlm_add(char const *, char const *);
