/* Z36
 * 0: 0x1                      1, 0, 1
 * 1: 0x2--0x3                 2, 1, 3
 * 2: 0x4--0x5                 3, 1, 4
 * 3: 0x6--0x7                 4, 1, 5
 * 4: 0x8--0xB                 5, 2, 7
 * 5: 0xC--0x13                6, 3, 9
 * 6: 0x14--0x53               7, 6, 13
 * 7: 0x54--                   8, 32, 40
 */
#define	ASSIGN_Z36(D) do {\
	register bitlist_reg_t v_v = (D);\
	if (v_v < 0x2) {\
		BITLIST_PUTBITS(~(bitlist_reg_t)1, 1, &b);\
	}\
	else if (v_v < 0x4) {\
		BITLIST_PUTBITS(~(bitlist_reg_t)1, 2, &b);\
		v_v -= 0x2;\
		BITLIST_PUTBITS(v_v, 1, &b);\
	}\
	else if (v_v < 0x6) {\
		BITLIST_PUTBITS(~(bitlist_reg_t)1, 3, &b);\
		v_v -= 0x4;\
		BITLIST_PUTBITS(v_v, 1, &b);\
	}\
	else if (v_v < 0x8) {\
		BITLIST_PUTBITS(~(bitlist_reg_t)1, 4, &b);\
		v_v -= 0x6;\
		BITLIST_PUTBITS(v_v, 1, &b);\
	}\
	else if (v_v < 0xC) {\
		BITLIST_PUTBITS(~(bitlist_reg_t)1, 5, &b);\
		v_v -= 0x8;\
		BITLIST_PUTBITS(v_v, 2, &b);\
	}\
	else if (v_v < 0x14) {\
		BITLIST_PUTBITS(~(bitlist_reg_t)1, 6, &b);\
		v_v -= 0xC;\
		BITLIST_PUTBITS(v_v, 3, &b);\
	}\
	else if (v_v < 0x54) {\
		BITLIST_PUTBITS(~(bitlist_reg_t)1, 7, &b);\
		v_v -= 0x14;\
		BITLIST_PUTBITS(v_v, 6, &b);\
	}\
	else {\
		BITLIST_PUTBITS(~(bitlist_reg_t)0, 7, &b);\
		v_v -= 0x54;\
		BITLIST_PUTBITS(v_v, 32, &b);\
	}\
} while (0)
#define	RETRIEVE_Z36(D) do {\
	register bitlist_reg_t v_v = 0;\
	BITLIST_GETBITS(v_v, 1, &b);\
	if (v_v==0) { \
		(D) = 1;\
		break;\
	}\
	BITLIST_GETBITS(v_v, 1, &b);\
	if (v_v==0) { \
		BITLIST_GETBITS(v_v, 1, &b);\
		(D) = v_v + 0x2;\
		break;\
	}\
	BITLIST_GETBITS(v_v, 1, &b);\
	if (v_v==0) { \
		BITLIST_GETBITS(v_v, 1, &b);\
		(D) = v_v + 0x4;\
		break;\
	}\
	BITLIST_GETBITS(v_v, 1, &b);\
	if (v_v==0) { \
		BITLIST_GETBITS(v_v, 1, &b);\
		(D) = v_v + 0x6;\
		break;\
	}\
	BITLIST_GETBITS(v_v, 1, &b);\
	if (v_v==0) { \
		BITLIST_GETBITS(v_v, 2, &b);\
		(D) = v_v + 0x8;\
		break;\
	}\
	BITLIST_GETBITS(v_v, 1, &b);\
	if (v_v==0) { \
		BITLIST_GETBITS(v_v, 3, &b);\
		(D) = v_v + 0xC;\
		break;\
	}\
	BITLIST_GETBITS(v_v, 1, &b);\
	if (v_v==0) { \
		BITLIST_GETBITS(v_v, 6, &b);\
		(D) = v_v + 0x14;\
		break;\
	}\
	BITLIST_GETBITS(v_v, 32, &b);\
	(D) = v_v + 0x54;\
} while (0)
/* NIB
 * 0: 0x1--0x400               1, 10, 11
 * 1: 0x401--0x1400            2, 12, 14
 * 2: 0x1401--0x3400           3, 13, 16
 * 3: 0x3401--0x7400           4, 14, 18
 * 4: 0x7401--0xF400           5, 15, 20
 * 5: 0xF401--0x17400          6, 15, 21
 * 6: 0x17401--0x37400         7, 17, 24
 * 7: 0x37401--                8, 32, 40
 */
#define	ASSIGN_NIB(D) do {\
	register bitlist_reg_t v_v = (D);\
	if (v_v < 0x401) {\
		BITLIST_PUTBITS(~(bitlist_reg_t)1, 1, &b);\
		v_v -= 0x1;\
		BITLIST_PUTBITS(v_v, 10, &b);\
	}\
	else if (v_v < 0x1401) {\
		BITLIST_PUTBITS(~(bitlist_reg_t)1, 2, &b);\
		v_v -= 0x401;\
		BITLIST_PUTBITS(v_v, 12, &b);\
	}\
	else if (v_v < 0x3401) {\
		BITLIST_PUTBITS(~(bitlist_reg_t)1, 3, &b);\
		v_v -= 0x1401;\
		BITLIST_PUTBITS(v_v, 13, &b);\
	}\
	else if (v_v < 0x7401) {\
		BITLIST_PUTBITS(~(bitlist_reg_t)1, 4, &b);\
		v_v -= 0x3401;\
		BITLIST_PUTBITS(v_v, 14, &b);\
	}\
	else if (v_v < 0xF401) {\
		BITLIST_PUTBITS(~(bitlist_reg_t)1, 5, &b);\
		v_v -= 0x7401;\
		BITLIST_PUTBITS(v_v, 15, &b);\
	}\
	else if (v_v < 0x17401) {\
		BITLIST_PUTBITS(~(bitlist_reg_t)1, 6, &b);\
		v_v -= 0xF401;\
		BITLIST_PUTBITS(v_v, 15, &b);\
	}\
	else if (v_v < 0x37401) {\
		BITLIST_PUTBITS(~(bitlist_reg_t)1, 7, &b);\
		v_v -= 0x17401;\
		BITLIST_PUTBITS(v_v, 17, &b);\
	}\
	else {\
		BITLIST_PUTBITS(~(bitlist_reg_t)0, 7, &b);\
		v_v -= 0x37401;\
		BITLIST_PUTBITS(v_v, 32, &b);\
	}\
} while (0)
#define	RETRIEVE_NIB(D) do {\
	register bitlist_reg_t v_v = 0;\
	BITLIST_GETBITS(v_v, 1, &b);\
	if (v_v==0) { \
		BITLIST_GETBITS(v_v, 10, &b);\
		(D) = v_v + 0x1;\
		break;\
	}\
	BITLIST_GETBITS(v_v, 1, &b);\
	if (v_v==0) { \
		BITLIST_GETBITS(v_v, 12, &b);\
		(D) = v_v + 0x401;\
		break;\
	}\
	BITLIST_GETBITS(v_v, 1, &b);\
	if (v_v==0) { \
		BITLIST_GETBITS(v_v, 13, &b);\
		(D) = v_v + 0x1401;\
		break;\
	}\
	BITLIST_GETBITS(v_v, 1, &b);\
	if (v_v==0) { \
		BITLIST_GETBITS(v_v, 14, &b);\
		(D) = v_v + 0x3401;\
		break;\
	}\
	BITLIST_GETBITS(v_v, 1, &b);\
	if (v_v==0) { \
		BITLIST_GETBITS(v_v, 15, &b);\
		(D) = v_v + 0x7401;\
		break;\
	}\
	BITLIST_GETBITS(v_v, 1, &b);\
	if (v_v==0) { \
		BITLIST_GETBITS(v_v, 15, &b);\
		(D) = v_v + 0xF401;\
		break;\
	}\
	BITLIST_GETBITS(v_v, 1, &b);\
	if (v_v==0) { \
		BITLIST_GETBITS(v_v, 17, &b);\
		(D) = v_v + 0x17401;\
		break;\
	}\
	BITLIST_GETBITS(v_v, 32, &b);\
	(D) = v_v + 0x37401;\
} while (0)
/* B36
 * 0: 0x1--0x8                 1, 3, 4
 * 1: 0x9--0x208               2, 9, 11
 * 2: 0x209--0x8208            3, 15, 18
 * 3: 0x8209--0x208208         4, 21, 25
 * 4: 0x208209--0x8208208      5, 27, 32
 * 5: 0x8208209--              6, 32, 38
 */
#define	ASSIGN_B36(D) do {\
	register bitlist_reg_t v_v = (D);\
	if (v_v < 0x9) {\
		BITLIST_PUTBITS(~(bitlist_reg_t)1, 1, &b);\
		v_v -= 0x1;\
		BITLIST_PUTBITS(v_v, 3, &b);\
	}\
	else if (v_v < 0x209) {\
		BITLIST_PUTBITS(~(bitlist_reg_t)1, 2, &b);\
		v_v -= 0x9;\
		BITLIST_PUTBITS(v_v, 9, &b);\
	}\
	else if (v_v < 0x8209) {\
		BITLIST_PUTBITS(~(bitlist_reg_t)1, 3, &b);\
		v_v -= 0x209;\
		BITLIST_PUTBITS(v_v, 15, &b);\
	}\
	else if (v_v < 0x208209) {\
		BITLIST_PUTBITS(~(bitlist_reg_t)1, 4, &b);\
		v_v -= 0x8209;\
		BITLIST_PUTBITS(v_v, 21, &b);\
	}\
	else if (v_v < 0x8208209) {\
		BITLIST_PUTBITS(~(bitlist_reg_t)1, 5, &b);\
		v_v -= 0x208209;\
		BITLIST_PUTBITS(v_v, 27, &b);\
	}\
	else {\
		BITLIST_PUTBITS(~(bitlist_reg_t)0, 5, &b);\
		v_v -= 0x8208209;\
		BITLIST_PUTBITS(v_v, 32, &b);\
	}\
} while (0)
#define	RETRIEVE_B36(D) do {\
	register bitlist_reg_t v_v = 0;\
	BITLIST_GETBITS(v_v, 1, &b);\
	if (v_v==0) { \
		BITLIST_GETBITS(v_v, 3, &b);\
		(D) = v_v + 0x1;\
		break;\
	}\
	BITLIST_GETBITS(v_v, 1, &b);\
	if (v_v==0) { \
		BITLIST_GETBITS(v_v, 9, &b);\
		(D) = v_v + 0x9;\
		break;\
	}\
	BITLIST_GETBITS(v_v, 1, &b);\
	if (v_v==0) { \
		BITLIST_GETBITS(v_v, 15, &b);\
		(D) = v_v + 0x209;\
		break;\
	}\
	BITLIST_GETBITS(v_v, 1, &b);\
	if (v_v==0) { \
		BITLIST_GETBITS(v_v, 21, &b);\
		(D) = v_v + 0x8209;\
		break;\
	}\
	BITLIST_GETBITS(v_v, 1, &b);\
	if (v_v==0) { \
		BITLIST_GETBITS(v_v, 27, &b);\
		(D) = v_v + 0x208209;\
		break;\
	}\
	BITLIST_GETBITS(v_v, 32, &b);\
	(D) = v_v + 0x8208209;\
} while (0)
