/*
 *	Copyright (C) 2001 Hitachi, Ltd.
 *	All rights reserved.
 *	Author: Shingo NISHIOKA
 *		nis@harl.hitachi.co.jp
 */

/* static char rcsid[] = "$Id: zvec_pub.c,v 1.2 2007/03/21 02:19:52 nis Exp $"; */

#include <config.h>

#if 1
#define DEBUG_ZVEC	1
#endif

#include <sys/param.h>
#include <sys/time.h>
#include <sys/stat.h>

#include <assert.h>
#include <stdarg.h>
#include <stddef.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <unistd.h>

#include <geta/dtypes.h>
#include <geta/dw.h>
#include <geta/dwut.h>
#include <geta/nlog.h>
#include <geta/dwerrno.h>
#include <geta/timer.h>
#include <geta/dcw.h>
#include <geta/dxr.h>
#include <geta/dwc.h>

#include "dwsys.h"
#include "sdup.h"
#include "dfi.h"
#include "dcwP.h"
#include "dxrP.h"
#include "zvec.h"

static struct {
	int i;
	char const *name;
} cnames[] = {
#define	FOO(n)	{COMPRESS_##n, #n}
	FOO(NONE),
	FOO(NIB),
	FOO(B36),
	FOO(Z36),
#undef FOO
};

int
dw_encode_compress(c)
char const *c;
{
	size_t i;
	for (i=0; i<nelems(cnames); i++) {
		if (!strcasecmp(c, cnames[i].name)) {
			return cnames[i].i;
		}
	}
	fprintf(stderr, "unknown compression type: [%s]\n", c);
	fprintf(stderr, "available compression types are (case insensitive):");
	for (i=0; i<nelems(cnames); i++) {
		fprintf(stderr, " %s", cnames[i].name);
	}
	fprintf(stderr, "\n");
	dwerrno = DWE_BADR;
	return -1;
}

char const *
dw_decode_compress(n)
{
	size_t i;
	for (i=0; i<nelems(cnames); i++) {
		if (cnames[i].i == n) {
			return cnames[i].name;
		}
	}
	dwerrno = DWE_BADR;
	return NULL;
}
